package space.eptaproject.vmodaddon;

import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.common.ForgeConfigSpec;

import java.util.List;
import java.util.Objects;

public class Config {
    public static final ForgeConfigSpec COMMON_CONFIG;
    public static final ForgeConfigSpec.ConfigValue<List<? extends String>> RESOURCE_LOCATION_LIST;
    public static final ForgeConfigSpec.ConfigValue<String> RESOURCE_LOCATION;

    public static List<ResourceLocation> parsedList = new ObjectArrayList<>();
    public static ResourceLocation replace = Validator.RB;

    static {
        ForgeConfigSpec.Builder builder = new ForgeConfigSpec.Builder();

        builder.push("Settings");

        RESOURCE_LOCATION_LIST = builder
                .comment("List of blocked blocks, format: 'modid:path'")
                .defineListAllowEmpty(
                        "blocked",
                        List.of("minecraft:stone", "minecraft:diamond_block"),
                        obj -> obj instanceof String && ResourceLocation.isValidResourceLocation((String) obj)
                );

        RESOURCE_LOCATION = builder
                .comment("replace to, format: 'modid:path'")
                .define(
                        "replace",
                        Validator.RB.toString()
                );

        builder.pop();
        COMMON_CONFIG = builder.build();
    }

    public static void bake() {
        parsedList = RESOURCE_LOCATION_LIST.get().stream()
                .map(s -> {
                    try {
                        return ResourceLocation.parse(s);
                    } catch (Exception e) {
                        return null;
                    }
                })
                .filter(Objects::nonNull)
                .toList();
        try {
            replace = ResourceLocation.parse(RESOURCE_LOCATION.get());
        } catch (Exception e) {
            replace = Validator.RB;
        }

    }
}
